# Contributing to ReDex

We want to make contributing to this project as easy and transparent as
possible.

## Our Development Process

This project is developed internally at Facebook inside a private repository.
Internal changes are periodically pushed to the open-source branch. Pull
requests are integrated manually into our private repository first, and they
then get propagated to the public repository with the next push.

## Pull Requests

We actively welcome your pull requests!

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs, update the documentation.
4. Ensure the test suite passes.
5. If you haven't already, complete the Contributor License Agreement ("CLA").

## Contributor License Agreement ("CLA")

In order to accept your pull request, we need you to submit a CLA. You only need
to do this once to work on any of Facebook's open source projects.

Complete your CLA here: <https://code.facebook.com/cla>

## Issues

We use GitHub issues to track public bugs. Please ensure your description is
clear and has sufficient instructions to be able to reproduce the issue.

Facebook has a [bounty program](https://www.facebook.com/whitehat/) for the safe
disclosure of security bugs. In those cases, please go through the process
outlined on that page and do not file a public issue.

## Coding Style  

Our only hard-and-fast coding style rules are:
* 2 spaces for indentation rather than tabs
* 80 character line length

In general, if you use our [.clang-format file](https://github.com/facebook/redex/blob/master/.clang-format), no one
will complain.

## License

By contributing to ReDex, you agree that your contributions will be licensed
under its BSD license.
